param HUGE;

set I circular := {1..6};
set J circular := {1..4};

param A {I, J};

#

var B {I, J}; # A[i, j - 1]
var C {I, J}; # A[i - 1, j - 1]

var x {I, J} binary;
var y {I, J} >= 0; # max(B[i, j], C[i, j])
var z {I, J} >= 0; # y if x

var t {I, J} binary; # y[i, j] == B[i, j]

var t1 {I, J} binary; # x & y
var t2 {I, J} binary; # x & !y

maximize f: sum {i in I, j in J} z[i, j];

subject to a1 {i in I, j in J}: B[i, j] = A[i, prev(j, J)];
subject to a2 {i in I, j in J}: C[i, j] = A[prev(i, I), prev(j, J)];

subject to b1 {i in I, j in J}: x[i, j] + x[i, next(j, J)] + x[i, next(next(j, J), J)] + x[i, next(next(next(j, J), J), J)] <= 3;

subject to c2 {i in I, j in J}: y[i, j] >= B[i, j];
subject to c3 {i in I, j in J}: y[i, j] >= C[i, j];
subject to c4 {i in I, j in J}: y[i, j] <= B[i, j] + HUGE * (1 - t[i, j]);
subject to c5 {i in I, j in J}: y[i, j] <= C[i, j] + HUGE * t[i, j];

subject to d2 {i in I, j in J}: z[i, j] <= y[i, j] * x[i, j];
subject to d4 {i in I, j in J}: z[i, j] <= B[i, j] * t1[i, j] + C[i, j] * t2[i, j];

subject to e1 {i in I, j in J}: t1[i, j] <= t[i, j];
subject to e2 {i in I, j in J}: t1[i, j] <= x[i, j];
subject to e3 {i in I, j in J}: t1[i, j] >= x[i, j] + t[i, j] - 1;

subject to f1 {i in I, j in J}: t2[i, j] <= 1 - t[i, j];
subject to f2 {i in I, j in J}: t2[i, j] <= x[i, j];
subject to f3 {i in I, j in J}: t2[i, j] >= x[i, j] - t[i, j];

# vim:set ft=ampl:
